package com.gingersoft.gsa.cloud.table.mvp.contract;

import android.app.Activity;
import android.widget.BaseAdapter;

import com.gingersoft.gsa.cloud.base.common.bean.BaseResult;
import com.gingersoft.gsa.cloud.database.bean.Combo;
import com.gingersoft.gsa.cloud.database.bean.FoodModifier;
import com.gingersoft.gsa.cloud.database.bean.Modifier;
import com.gingersoft.gsa.cloud.table.mvp.model.bean.BaseRespose;
import com.gingersoft.gsa.cloud.database.bean.Food;
import com.gingersoft.gsa.cloud.table.mvp.model.bean.request.OrderRequest;
import com.gingersoft.gsa.cloud.table.mvp.presenter.MealStandPresenter;
import com.gingersoft.gsa.cloud.table.mvp.ui.activity.MealStandActivity;
import com.jess.arms.base.DefaultAdapter;
import com.jess.arms.mvp.IModel;
import com.jess.arms.mvp.IView;

import java.util.List;

import androidx.recyclerview.widget.RecyclerView;
import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 12/27/2019 19:17
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
public interface MealStandContract {
    //对于经常使用的关于UI的方法可以定义到IView中,如显示隐藏进度条,和显示文字消息
    interface View extends BaseOrderContract.View {

        boolean isInitFineItemLayout();

        void initFineItemTabBarViewPage();

        void showFinePage();

        void setPluMode();

        void resetPluMode();

        void recordOperat(boolean isPressButtonSound);

        void showChoosePeopleNumDialog(boolean isNeedCancel);

        void setPrinterLocalmachine(boolean isPrint);

        void setTableInfoDialogAdapter(BaseAdapter adapter);

        void setSelectFoodAdapter(RecyclerView.Adapter adapter);

        void setFoodGroupAdapter(DefaultAdapter adapter);

        void setFoodAdapter(DefaultAdapter adapter);

        void setComboAdapter(DefaultAdapter adapter);

        void setDiscountAdapter(DefaultAdapter adapter);

        void setSelectFoodRecycleLayoutManager();

        void setFoodGroupRecycleLayoutManager(int orientation);

        void setFoodRecycleLayoutManager(int orientation);

        void setComboRecycleLayoutManager(int orientation);

        void setDiscountRecycleLayoutManager(int orientation);

        void setFoodGroupRecycleSpanCount(int size);

        void setFoodRecycleSpanCount(int size);

        void setComboRecycleSpanCount(int size);

        void setDiscountRecycleSpanCount(int size);

        void showViewModeVisibility(int... viewMode);

        void showModifyLayoutVisibility(boolean show);

        void setOrderFoodCount(String number);

        void setMealRvScrollToPosition(int position);

        Activity getActivity();
    }

    //Model层定义接口,外部只需关心Model返回的数据,无需关心内部细节,即是否使用缓存
    interface Model extends BaseOrderContract.Model {

        Observable<BaseRespose> loadOrder(int orderId);

        Observable<BaseResult> createOrder(RequestBody requestBody);

        Observable<BaseResult> addFood(RequestBody requestBody);

        Observable<BaseRespose> deleteFood(RequestBody requestBody);

        Observable<BaseRespose> printOrder(RequestBody requestBody);

        List<Food> queryDB_FoodGroupList();

        List<Food> queryDB_FoodList(long parentId);

        List<Modifier> queryDB_ModifierList(long fid);

        List<Combo> queryDB_ComboList(long fid);

        List<Combo> isComboFood(long fid);

        List<FoodModifier> queryDB_FoodModifierList(long fid);
    }
}
